package ink.wgink.module.activiti.controller.api;

import ink.wgink.common.base.DefaultBaseController;
import ink.wgink.interfaces.consts.ISystemConstant;
import ink.wgink.module.activiti.service.activiti.IActivitiUserTaskService;
import ink.wgink.pojo.result.SuccessResult;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: ActivitiUserTaskController
 * @Description: 流程用户任务
 * @Author: WangGeng
 * @Date: 2021/7/12 21:56
 * @Version: 1.0
 **/
@Api(tags = ISystemConstant.API_TAGS_SYSTEM_PREFIX + "流程用户任务接口")
@RestController
@RequestMapping(ISystemConstant.API_PREFIX + "/activiti/user-task")
public class ActivitiUserTaskController extends DefaultBaseController {

    @Autowired
    private IActivitiUserTaskService activitiUserTaskService;

    @GetMapping("get-next-user-task/{userTaskId}")
    public SuccessResult getNextUserTask(@PathVariable("userTaskId") String userTaskId) {
        activitiUserTaskService.getNextUserTask(userTaskId);
        return new SuccessResult();
    }

}
