package ink.wgink.module.activiti.listener.task;

import ink.wgink.module.activiti.service.activiti.IActivitiModelService;
import ink.wgink.module.activiti.service.oa.IOaFormReportService;
import org.activiti.bpmn.model.UserTask;
import org.activiti.engine.RuntimeService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.DelegateTask;
import org.activiti.engine.delegate.JavaDelegate;
import org.activiti.engine.delegate.TaskListener;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: OaUserTaskCompleteListener
 * @Description: OA用户任务节点完成监听器
 * @Author: wanggeng
 * @Date: 2022/3/28 10:31
 * @Version: 1.0
 */
@Component
public class OaUserTaskCompleteListener implements TaskListener, JavaDelegate {

    private static final Logger LOG = LoggerFactory.getLogger(OaUserTaskCompleteListener.class);

    @Autowired
    private RuntimeService runtimeService;

    @Autowired
    private IActivitiModelService activitiModelService;
    @Autowired
    private IOaFormReportService oaFormReportService;

    @Override
    public void notify(DelegateTask delegateTask) {
        LOG.debug(">>>> userTask complete");
        Map<String, Object> variables = delegateTask.getVariables();


        LOG.debug("查询表单数据：variables: {}", variables);
        UserTask nextUserTask = activitiModelService.getNextUserTask(delegateTask.getTaskDefinitionKey(), delegateTask.getProcessDefinitionId(), variables);
        if (nextUserTask != null) {
            if (StringUtils.equals(nextUserTask.getName(), "任务3")) {
//                nextUserTask.setAssignee("${signUser}");
//                MultiInstanceLoopCharacteristics characteristics = new MultiInstanceLoopCharacteristics();
//                characteristics.setInputDataItem("signUsers");
//                characteristics.setElementVariable("signUser");
//                characteristics.setSequential(false);
//                characteristics.setCompletionCondition("${nrOfCompletedInstances==nrOfInstances}");
//                nextUserTask.setLoopCharacteristics(characteristics);

                List<String> signUsers = new ArrayList<>();
                signUsers.add("1");
                signUsers.add("e48e9c4a-995e-4061-abcd-a3c260c11333");

//                runtimeService.setVariable(delegateTask.getExecutionId(), "signUsers", signUsers);
                delegateTask.setVariable("signUsers", signUsers);
            } else {
                nextUserTask.setAssignee("1");
            }
        }

    }

    @Override
    public void execute(DelegateExecution execution) {

    }


    // 1、nrOfInstances 该会签环节中总共有多少个实例 2、nrOfActiveInstances 当前活动的实例的数量，即还没有 完成的实例数量。 3、nrOfCompletedInstances 已经完成的实例的数量

    // 设置会签
//        // 获取多实例配置
//        MultiInstanceLoopCharacteristics characteristics = new MultiInstanceLoopCharacteristics();
//        // 设置集合变量，统一设置成users
//        characteristics.setInputDataItem(Constant.ACT_MUIT_LIST_NAME);
//        // 设置变量
//        characteristics.setElementVariable(Constant.ACT_MUIT_VAR_NAME);
//        // 设置为同时接收（false 表示不按顺序执行）
//        characteristics.setSequential(false);
//        // 设置条件（暂时处理成，全部会签完转下步）
//        characteristics.setCompletionCondition("${nrOfCompletedInstances==nrOfInstances}");
//
//        userTask.setLoopCharacteristics(characteristics);


    // 清空会签
    // 获取多实例配置
//        MultiInstanceLoopCharacteristics characteristics = userTask.getLoopCharacteristics();
//        if (characteristics != null) {
//            // 清空集合
//            characteristics.setInputDataItem("");
//            // 清空变量
//            characteristics.setElementVariable("");
//            // 设置为顺序接收（true 表示不按顺序执行）
//            characteristics.setSequential(true);
//            // 清空条件
//            characteristics.setCompletionCondition("");
//        }

}
