package ink.wgink.module.activiti.service.oa;

import ink.wgink.module.activiti.pojo.vos.oa.nodemanage.config.AssigneeVO;

/**
 * @ClassName: INodeAssigneeService
 * @Description: 节点代理人
 * @Author: wanggeng
 * @Date: 2022/4/4 15:08
 * @Version: 1.0
 */
public interface INodeAssigneeService {

    /**
     * 保存
     *
     * @param modelId
     * @param modelVersion
     * @param nodeId
     * @param nodeIndex
     * @param assignee
     */
    void save(String modelId, Integer modelVersion, String nodeId, int nodeIndex, AssigneeVO assignee);

    /**
     * 更新
     *
     * @param modelId
     * @param modelVersion
     * @param nodeId
     * @param nodeIndex
     * @param assignee
     */
    void update(String modelId, Integer modelVersion, String nodeId, int nodeIndex, AssigneeVO assignee);

    /**
     * 更新部署ID
     *
     * @param modelId
     * @param version
     * @param deploymentId
     */
    void updateDeploymentId(String modelId, Integer version, String deploymentId);

    /**
     * 删除部署ID
     *
     * @param deploymentId
     */
    void deleteDeploymentId(String deploymentId);

    /**
     * 删除
     *
     * @param modelId      模型ID
     * @param modelVersion 模型版本
     */
    void deleteByModelIdAndModelVersion(String modelId, Integer modelVersion);
}
