package ink.wgink.module.activiti.service.oa;

import java.util.Map;

/**
 * @ClassName: IOAFormReportService
 * @Description: OA表单上报
 * @Author: wanggeng
 * @Date: 2022/3/22 22:05
 * @Version: 1.0
 */
public interface IOaFormReportService {

    String KEY_FORM_CODE = "formCode";
    String KEY_FORM_VERSION = "formVersion";
    String KEY_REPORT_UID = "reportUid";

    /**
     * 保存表单
     *
     * @param processDefinitionId 流程定义ID
     * @param formCode            表单编码
     * @param formVersion         表单版本
     * @param params              表单参数
     */
    void save(String processDefinitionId, String formCode, Integer formVersion, Map<String, Object> params);

    /**
     * 更新表单
     *
     * @param taskId
     * @param formCode
     * @param formVersion
     * @param uid
     * @param params
     */
    void update(String taskId, String formCode, Integer formVersion, String uid, Map<String, Object> params);

    /**
     * 表单详情
     *
     * @param formCode
     * @param formVersion
     * @param uid
     */
    Map<String, Object> get(String formCode, Integer formVersion, String uid);

}
