package ink.wgink.module.activiti.service.oa.impl;

import ink.wgink.common.base.DefaultBaseService;
import ink.wgink.module.activiti.service.oa.IOaFormReportRouteService;
import ink.wgink.module.form.service.report.IFormReportRouteService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.Map;

/**
 * @ClassName: OaFormReportRouteServiceImpl
 * @Description: oa表单提交
 * @Author: wanggeng
 * @Date: 2022/3/24 09:31
 * @Version: 1.0
 */
@Service
public class OaFormReportRouteServiceImpl extends DefaultBaseService implements IOaFormReportRouteService {

    @Autowired
    private IFormReportRouteService formReportRouteService;

    @Override
    public void save(String processDefinitionId, String formCode, Integer formVersion, HttpSession httpSession, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) {
        Map<String, Object> modal = getHashMap(10);
        modal.put("processDefinitionId", processDefinitionId);
        formReportRouteService.save(formCode, formVersion, httpSession, httpServletRequest, httpServletResponse, modal);
    }

    @Override
    public void update(String taskId, String formCode, Integer formVersion, HttpSession httpSession, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) {
        Map<String, Object> modal = getHashMap(10);
        modal.put("taskId", taskId);
        formReportRouteService.update(formCode, formVersion, httpSession, httpServletRequest, httpServletResponse, modal);
    }

    @Override
    public void show(String formCode, Integer formVersion, HttpSession httpSession, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) {

    }
}
