layui.define(['jquery', 'form', 'formUtils'], function(exports) {
    var $ = layui.jquery;
    var form = layui.form;
    var utils = layui.formUtils;
    var formField = layui.formField;

    var checkbox = {
        /**
         * 根据json对象生成html对象
         * @param {object} json
         * @param {boolean} selected true 表示选择当前
         * */
        render: function (json, selected) {
            if (selected === undefined) {
                selected = false;
            }
            var _disabled = json.disabled ? 'disabled=""' : '';
            var _required = json.required ? 'lay-verify="otherReq"' : '';
            var _html = '<div id="{0}" class="layui-form-item {2}"  data-id="{0}" data-tag="{1}" data-index="{3}">'.format(json.id, json.tag, selected ? 'active' : '', json.index);
            _html += '<label class="layui-form-label {0}" style="width: {3}px"><span style="color:red;">{2}</span>{1}:</label>'.format(json.required ? 'layui-form-required' : '', json.label, json.required ? '*' : '', json.labelWidth);
            _html += '<div class="layui-input-block" style="width:calc({0} - {1}px);margin-left: {1}px;">'.format(json.width, json.labelWidth);
            for (var i = 0; i < json.options.length; i++) {
                if (json.options[i].checked) {
                    _html += '<input type="checkbox" name="{0}[{1}]" title="{2}" checked="" {3} {4}>'.format(json.id, json.options[i].value, json.options[i].text, _disabled, _required);
                } else {
                    _html += '<input type="checkbox" name="{0}[{1}]" title="{2}" {3} {4}>'.format(json.id, json.options[i].value, json.options[i].text, _disabled, _required);
                }
            }
            _html += '</div>';
            _html += '</div>';
            return _html;
        },
        update: function (json) {
            var _disabled = json.disabled ? 'disabled=""' : '';
            var _required = json.required ? 'lay-verify="otherReq"' : '';
            var $block = $('#' + json.id + ' .layui-input-block');
            var $label = $('#' + json.id + ' .layui-form-label');
            $block.empty();
            $label.empty();
            var _html = '';
            //重绘设计区改id下的所有元素
            for (var i = 0; i < json.options.length; i++) {
                if (json.options[i].checked) {
                    _html += '<input type="checkbox" name="{0}[{1}]" title="{2}" checked="" {3} {4}>'.format(json.id, json.options[i].value, json.options[i].text, _disabled, _required);
                } else {
                    _html += '<input type="checkbox" name="{0}[{1}]" title="{2}" {3} {4}>'.format(json.id, json.options[i].value, json.options[i].text, _disabled, _required);
                }
            }
            $block.append(_html);
            $block.css("margin-left", json.labelWidth);
            $label.css("width", json.labelWidth);
            if (json.required) {
                $label.append('<span style="color:red;">*</span>');
            }
            $label.append(json.label + ":");
            form.render('checkbox');
        },
        /* 获取对象 */
        jsonData: function (id, index, columncount) {
            //分配一个新的ID
            var _json = JSON.parse(JSON.stringify(formField.checkbox));
            _json.id = id == undefined ? utils.guid() : id;
            _json.index = index;
            return _json;
        },
        /* 根据 json 对象显示对应的属性 */
        property: function (json) {
            $('#columnProperty').empty();
            var _html = '';
            _html = utils.renderCommonProperty(json); //获取通用属性HTML字符串
            //处理特殊字符串
            for (var key in json) {
                if (key === 'index') {
                    continue;
                }
            }
            $('#columnProperty').append(_html);
        },
        genScript: function(item) {
            return {
                func: {
                    save: '',
                    update: ''
                },
                init: {
                    save: '',
                    update: [
                        '               var ' + item.id + ' = data.' + item.id + '.split(\',\');',
                        '               var '+ item.id +'Obj = {};',
                        '               for(var i = 0, item = ' + item.id + '[i]; item = ' + item.id + '[i++];) {',
                        '                   '+ item.id +'Obj[\'' + item.id + '[\'+ item +\']\'] = true;',
                        '               }',
                        '               form.val(\'dataForm\', '+ item.id +'Obj);',
                    ].join('\n')
                },
                commit: [
                    '               var ' + item.id + ' = top.restAjax.checkBoxToString(formData.field, \'' + item.id + '\');',
                    '               formData.field.' + item.id + ' = ' + item.id + ';'
                ].join('\n'),
            }

        }
    }

    exports('checkbox', checkbox);
});