layui.define(['jquery', 'upload', 'dialog', 'restajax', 'formUtils'], function(exports) {
    var $ = layui.jquery;
    var upload = layui.upload;
    var utils = layui.formUtils;
    var dialog = layui.dialog;
    var restAjax = layui.restajax;
    var formField = layui.formField;

    var uploadFile = {
        /**
         * 根据json对象生成html对象
         * @param {object} json
         * @param {boolean} selected true 表示选择当前
         * */
        render: function (json, selected) {
            if (selected === undefined) {
                selected = false;
            }
            var _html = '<div id="{0}" class="layui-form-item {2}"  data-id="{0}" data-tag="{1}" data-index="{3}">'.format(json.id, json.tag, selected ? 'active' : '', json.index);
            _html += '<label class="layui-form-label {0}">{1}:</label>'.format(json.required ? 'layui-form-required' : '', json.label);
            _html += '<div class="layui-input-block">';
            _html += '<div class="layui-upload">';
            _html += '<button type="button" class="layui-btn layui-btn-normal" id="{0}">选择多文件</button> '.format(json.tag + json.id);
            _html += ' <div class="layui-upload-list" style="max-width: 1000px;"><table class="layui-table">';
            _html += '<colgroup><col><col width="150"><col width="260"><col width="150"></colgroup>';
            _html += '<thead><tr><th>文件名</th><th>大小</th><th>上传进度</th><th>操作</th></tr></thead>';
            _html += '<tbody id="list-{0}"></tbody></table></div>'.format(json.id);
            _html += '<button type="button" class="layui-btn" id="listAction-{0}">开始上传</button>'.format(json.id);
            _html += '</div>';
            _html += '</blockquote>';
            _html += '</div>';
            _html += '</div>';
            _html += '</div>';
            return _html;
        },
        update: function(json) {
            $('#'+ json.id +' .layui-form-label').text(json.label);
        },
        /* 获取对象 */
        jsonData: function (id, index, columncount) {
            //分配一个新的ID
            var _json = JSON.parse(JSON.stringify(formField.uploadFile));
            _json.id = id == undefined ? utils.guid() : id;
            _json.index = index;
            return _json;
        },
        /* 根据 json 对象显示对应的属性 */
        property: function (json) {
            $('#columnProperty').empty();
            var _html = '';
            _html = utils.renderCommonProperty(json); //获取通用属性HTML字符串
            //处理特殊字符串
            for (var key in json) {
                if (key === 'index') {
                    continue;
                }
            }
            $('#columnProperty').append(_html);
        },
        componentRender: function(item) {
            upload.render({
                elem: '#' + item.tag + item.id,
                elemList: $('#list-' + item.id),
                url: '' + item.uploadUrl + '',
                accept: 'file',
                multiple: true,
                number: 3,
                auto: false,
                bindAction: '#listAction-' + item.id,
                choose: function (obj) {
                    var that = this;
                    var files = this.files = obj.pushFile(); //将每次选择的文件追加到文件队列
                    //读取本地文件
                    obj.preview(function (index, file, result) {
                        var tr = $(['<tr id="upload-' + index + '">', '<td>' + file.name + '</td>', '<td>' + (file.size / 1014).toFixed(1) + 'kb</td>', '<td><div class="layui-progress" lay-filter="progress-demo-' + index + '"><div class="layui-progress-bar" lay-percent=""></div></div></td>', '<td>', '<button class="layui-btn layui-btn-xs demo-reload layui-hide">重传</button>', '<button class="layui-btn layui-btn-xs layui-btn-danger demo-delete">删除</button>', '</td>', '</tr>'].join(''));
                        //单个重传
                        tr.find('.demo-reload').on('click', function () {
                            obj.upload(index, file);
                        });
                        //删除
                        tr.find('.demo-delete').on('click', function () {
                            delete files[index]; //删除对应的文件
                            tr.remove();
                            uploadListIns.config.elem.next()[0].value = ''; //清空 input file 值，以免删除后出现同名文件不可选
                        });
                        that.elemList.append(tr);
                        element.render('progress'); //渲染新加的进度条组件
                    });
                },
                done: function (res, index, upload) { //成功的回调
                    var that = this;
                    //if(res.code == 0){ //上传成功
                    var tr = that.elemList.find('tr#upload-' + index),
                        tds = tr.children();
                    tds.eq(3).html(''); //清空操作
                    delete this.files[index]; //删除文件队列已经上传成功的文件
                    return;
                    //}
                    this.error(index, upload);
                },
                allDone: function (obj) { //多文件上传完毕后的状态回调
                    console.log(obj)
                },
                error: function (index, upload) { //错误回调
                    var that = this;
                    var tr = that.elemList.find('tr#upload-' + index),
                        tds = tr.children();
                    tds.eq(3).find('.demo-reload').removeClass('layui-hide'); //显示重传
                },
                progress: function (n, elem, e, index) {
                    element.progress('progress-demo-' + index, n + '%'); //执行进度条。n 即为返回的进度百分比
                }
            });
        }
    };

    exports('uploadFile', uploadFile)
});